#include <bits/stdc++.h>

const double EPS = 1e-9;

struct File {
    int start, size, id;

    File() {
        start = size = id = 0;
    }

    File(int start, int size, int id)  : start(start), size(size), id(id) {
    }
};

bool operator < (File const& a, File const &b) {
    return a.start < b.start;
}

int main() {
    freopen("downloading.in", "r", stdin);
    freopen("downloading.out", "w", stdout);
    int n, v;
    scanf("%d%d", &n, &v);
    std::vector <File> files;
    for (int i = 0; i < n; i++) {
        int start, size;
        scanf("%d%d", &start, &size);
        File newFile(start, size, i);
        files.push_back(newFile);
    }
    files.push_back(File((int)2e9, 0, n));

    std::set <std::pair <double, int> > leftSize;
    leftSize.insert(std::make_pair(files[0].size, 0));
    int filesCopying = 1;
    double subtracted = 0;
    std::vector <double> answer(n);
    double lastEvent = files[0].start;
    for (int i = 1; i < n || !leftSize.empty();) {
        while (!leftSize.empty() && fabs(leftSize.begin()->first - subtracted) <= EPS) {
            int id = leftSize.begin()->second;
            answer[files[id].id] = lastEvent;
            --filesCopying;
            leftSize.erase(leftSize.begin());
        }
        if (leftSize.empty())
            subtracted = 0;
        double elapsedTime = (i < n ? files[i].start - lastEvent : 1e18);
        if (!leftSize.empty() && elapsedTime * v >= (leftSize.begin()->first - subtracted) * filesCopying) {
            int id = leftSize.begin()->second;
            answer[files[id].id] = lastEvent + (leftSize.begin()->first - subtracted) / (v * 1.0 / filesCopying);
            subtracted += (answer[files[id].id] - lastEvent) * (v * 1.0 / filesCopying);
            --filesCopying;
            lastEvent = answer[files[id].id];
            leftSize.erase(leftSize.begin());
            if (leftSize.empty())
                subtracted = 0;
        } else {
            int id = files[i].id;
            if (leftSize.empty())
                subtracted = 0;
            else
                subtracted += (files[i].start - lastEvent) * (v * 1.0 / filesCopying);
            lastEvent = files[i].start;
            if (i < n)
                leftSize.insert(std::make_pair(files[i].size + subtracted, id));
            ++filesCopying;
            ++i;
        }
    }
    for (int i = 0; i < n; i++) {
        printf("%.17lf\n", answer[i]);
    }
    return 0;
}           