import random
import math
random.seed("personal03")

class TestGen:
    def __init__(self):
        self.test_number = 0
        self.desc_file = open("../tests.desc", "w")

    def generate_samples(self):
        self.print_test(2, 2, [(1, 1), (3, 1)], "subtask0", "test from sample", 0, "preliminary")
        self.print_test(2, 1, [(1, 2), (2, 2)], "subtask0", "test from sample", 0, "preliminary")

    def generate_random_test(self, f, maxn, maxv, maxx, subtask):
        n = random.randint(1, maxn)
        v = random.randint(1, maxv)
        files = [[0, 0] for i in range(n)]
        for i in range(n):
            files[i][0] = random.randint(1, maxx)
            if f:
                files[i][0] = 1
            files[i][1] = random.randint(1, maxx)
        self.print_test(n, v, files, subtask, "random test, n = %d, v = %d" % (n, v))

    def generate_max_test(self, f, maxn, maxv, maxx, subtask):
        n = maxn
        v = random.randint(1, maxv)
        last = 1
        files = [[0, 0] for i in range(n)]
        for i in range(n):
            x = last
            size = random.randint(1, maxx // n)
            last += size
            files[i] = [x, size]
            if f:
                files[i][0] = 1
        self.print_test(n, v, files, subtask, "max test - non intersect segments, n = %d, v = %d" % (n, v))

        n = maxn
        v = random.randint(1, maxv)
        files = [[0, 0] for i in range(n)]
        for i in range(n):
            size = random.randint(1, maxx)
            files[i] = [1, size]
            if f:
                files[i][0] = 1
        self.print_test(n, v, files, subtask, "max test - segments [1, random], n = %d, v = %d" % (n, v))

        n = maxn
        v = maxv
        last = 1
        files = [[0, 0] for i in range(n)]
        for i in range(n):
            x = last
            size = maxx // n
            last += size
            files[i] = [x, size]
            if f:
                files[i][0] = 1
        self.print_test(n, v, files, subtask, "max test - non intersect segments, n = %d, v = %d" % (n, v))

        n = maxn
        v = random.randint(1, maxv)
        files = [[0, 0] for i in range(n)]
        for i in range(n):
            size = maxx
            files[i] = [1, size]
            if f:
                files[i][0] = 1
        self.print_test(n, v, files, subtask, "max test - segments [1, random], n = %d, v = %d" % (n, v))

    def generate_first_group(self):
        self.print_test(1, 1, [[1, 1]], "subtask1", "min test, n = 1, v = 1")
        self.print_test(1, 1, [[1, 50]], "subtask1", "min test, n = 1, v = 1")
        self.print_test(1, 1, [[1, 10**9]], "subtask1", "min test, n = 1, v = 1")
        self.print_test(3, 2, [[1, 1], [1, 2], [1, 3]], "subtask1", "min test, n = 3, v = 2")
        self.print_test(3, 2, [[1, 1], [1, 3], [1, 2]], "subtask1", "min test, n = 3, v = 2")
        self.print_test(3, 2, [[1, 1], [1, 3], [1, 2]], "subtask1", "min test, n = 3, v = 2")
        self.print_test(3, 2, [[1, 3], [1, 2], [1, 1]], "subtask1", "min test, n = 3, v = 2")
        for i in range(5):
            self.generate_random_test(True, 20, 10**9, 10**9, "subtask1")
        self.generate_max_test(True, 20, 10**9, 10**9, "subtask1")

    def generate_second_group(self):
        self.print_test(1, 1, [(1, 1)], "subtask2", "min test, n = 1, v = 1")
        self.print_test(1, 1, [(100, 50)], "subtask2", "min test, n = 1, v = 1")
        self.print_test(1, 1, [(10**9, 10**9)], "subtask2", "min test, n = 1, v = 1")
        self.print_test(3, 2, [[1, 1], [2, 2], [3, 3]], "subtask2", "min test, n = 3, v = 2")
        self.print_test(3, 2, [[1, 1], [3, 3], [2, 2]], "subtask2", "min test, n = 3, v = 2")
        self.print_test(3, 2, [[1, 1], [3, 3], [2, 2]], "subtask2", "min test, n = 3, v = 2")
        self.print_test(3, 2, [[1, 3], [2, 2], [3, 1]], "subtask2", "min test, n = 3, v = 2")
        for i in range(5):
            self.generate_random_test(False, 1000, 10**9, 10**9, "subtask2")
        self.generate_max_test(False, 1000, 10**9, 10**9, "subtask2")

    def generate_third_group(self):
        self.print_test(1, 1, [(1, 1)], "subtask3", "min test, n = 1, v = 1")
        self.print_test(1, 1, [(100, 50)], "subtask3", "min test, n = 1, v = 1")
        self.print_test(1, 1, [(10**9, 10**9)], "subtask3", "min test, n = 1, v = 1")
        self.print_test(3, 2, [[1, 1], [2, 2], [3, 3]], "subtask3", "min test, n = 3, v = 2")
        self.print_test(3, 2, [[1, 1], [3, 3], [2, 2]], "subtask3", "min test, n = 3, v = 2")
        self.print_test(3, 2, [[1, 1], [3, 3], [2, 2]], "subtask3", "min test, n = 3, v = 2")
        self.print_test(3, 2, [[1, 3], [2, 2], [3, 1]], "subtask3", "min test, n = 3, v = 2")
        for i in range(5):
            self.generate_random_test(False, 10**5, 10**9, 10**9, "subtask3")
        self.generate_max_test(False, 10**5, 10**9, 10**9, "subtask3")
    
    def print_test(self, n, v, files, subtask, description, points=0, folder="tests"):
        self.test_number += 1
        print("Generating test %s\%d" % (subtask, self.test_number))
        test_name = "../" + folder + "/{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(n, v, file=test_file)
        #random.shuffle(files)
        files.sort()
        print('\n'.join(' '.join(str(element) for element in f) for f in files), file=test_file)
        print(test_name + ", folder=" + folder + ", subtask=" + subtask + ", points=" + str(points) + ", comment=\"" + description + "\"", file=self.desc_file)
        test_file.close()                                                                                             

    def generate_all_tests(self):
        self.generate_samples()
        self.test_number = 0

        #First group of tests
        self.generate_first_group()       #tests 01-##
        print("comment_subtask1=\"n &lt;= 100, all start points are equal 1\"", file=self.desc_file)
        print("bonus_subtask1=30", file=self.desc_file)

        #Second group of tests
        self.generate_second_group()      #tests ##-##
        print("comment_subtask2=\"n &lt;= 1000\"", file=self.desc_file)
        print("bonus_subtask2=30", file=self.desc_file)
        
        #Third group of tests
        self.generate_third_group()       #tests ##-##
        print("comment_subtask3=\"n &lt;= 100000\"", file=self.desc_file)
        print("bonus_subtask3=40", file=self.desc_file)

        self.desc_file.close()

import os, shutil
if os.path.exists('../preliminary'):
    print('Directory preliminary already exists')
    shutil.rmtree('../preliminary', ignore_errors=False, onerror=None)
if os.path.exists('../tests'):
    print('Directory tests already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../preliminary')
    os.makedirs('../tests')
except OSError:                                                                                                                      
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)